// Main Container Function, that calls itself
(function() {

	var expandProperties = {}, listeners, placementType, state, states, viewable, __slice = Array.prototype.slice;

	states = [ "loading", "hidden", "default", "expanded", "resized" ];

	placementType = "inline";

	state = "loading";

	viewable = false;
	
	var density = 1;
	
	var volume = 0;
	
	listeners = {};
	/* Tilt values */
	var tiltValues = {
			x : 0,
			y : 0,
			z : 0,
		};
	
	var absSize = {
			x : 0,
			y : 0,
			width : 0,
			height : 0
		};

	this.non_mraid = {
		setDurationTime : function(milliseconds) {
			console.log("setDurationTime(" + milliseconds + ")");
            this.displayDurationTime = milliseconds;
        },

        startDurationTimer : function() {
        	console.log("startDurationTimer()");
            if(this.displayDurationTime > 0){
                this.displayDurationTimer = window.setTimeout(mraid.close, this.displayDurationTime);
            }
        },

        stopDurationTimer : function() {
        	console.log("stopDurationTimer()");
            window.clearTimeout(this.displayDurationTimer);
        }
	}
	
	// Main Body
	this.mraid = {
	    
		setDensity : function(dens) {
			
			density = dens;
		},
		
		setVolumeValue : function(vol) {
			volume = vol;
		},
		
		getDensity : function() {
			
			return density;
		},
		
		setTiltValues : function(x, y, z) {
			
			tiltValues.x = x;
			tiltValues.y = y;
			tiltValues.z = z;
			
		},
		
		setAbsoluteSize : function(width, height) {
			
			absSize.width = width;
			absSize.height = height;
		},
		
	    setDeviceVolume : function(volume){
	    	return mraid_bridge.setDeviceVolume(volume);
	    },	
			
		getVersion : function() {
			return "1.0";
		},

		getState : function() {
			return state;
		},

		isViewable : function() {
			return viewable;
		},

		close : function() {
			return mraid_bridge.close();
		},

		/*open : function(url) {
			return mraid_bridge.open(url);
			// return mraid_bridge.openRichMediaAdOverlay(url);
		},*/

		open : function(url1, bool, url2) {
			
			if(bool === undefined || url2 === undefined) {
				return mraid_bridge.openInAppView(url1);
			} else {
				return mraid_bridge.open(url1, bool, url2);
			}
		},

		addEventListener : function(event, listener) {

			mraid_bridge.logMessage("adding event listener for " + event);
			if (event === "ready" || event === "stateChange"
					|| event === "viewableChange" || event === "error" 
						|| event === "tiltChange" || event === "volumeChange") {
				
				if(event === "tiltChange") {
					mraid_bridge.addedTiltEvenetListener();
				}
				return (listeners[event] || (listeners[event] = []))
						.push(listener);
			}
		},
		removeEventListener : function() {
			var event, l, listener;
			event = arguments[0], listener = 2 <= arguments.length ? __slice
					.call(arguments, 1) : [];
			if (listeners[event] && listener.length > 0) {
				return listeners[event] = (function() {
					var _i, _len, _ref, _results;
					_ref = listeners[event];
					_results = [];
					for (_i = 0, _len = _ref.length; _i < _len; _i++) {
						l = _ref[_i];
						if (l !== listener[0])
							_results.push(l);
					}
					return _results;
				})();
			} else {
				return delete listeners[event];
			}
		},

		testEvent : function() {
			mraid_bridge.logMessage("fireEvent : ");
		},

		fireEvent : function(event) {

			var listener, _i, _len, _ref, _results;
			//mraid_bridge.logMessage("fireEvent : " + event);
			if (listeners[event]) {
				_ref = listeners[event];
				_results = [];
				for (_i = 0, _len = _ref.length; _i < _len; _i++) {
					listener = _ref[_i];
					if (event === "ready")
						listener();
					if (event === "stateChange")
						listener(state);
					if(event === "tiltChange") {
						//alert(tiltValues.y);
						listener(tiltValues.x, tiltValues.y, tiltValues.z);
					}
					if(event === "volumeChange") {
						listener(volume);
					}
					if (event === "viewableChange") {
						_results.push(listener(viewable));
					} else {
						_results.push(void 0);
					}
				}
				return _results;
			}
		},

		setState : function(state_id) {
			switch (state_id) {
			case 0:
				state = "loading";
				break;
			case 1:
				state = "hidden";
				break;
			case 2:
				state = "default";
				break;
			case 3:
				state = "expanded";
				break;
			case 4:
				state = "resized";
			}
			mraid_bridge.logMessage("in setState : " + state);
			return mraid.fireEvent("stateChange");
		},
		
		setViewable : function(is_viewable) {
			viewable = is_viewable;
			return mraid.fireEvent("viewableChange");
		},

		openModalVCWithURL : function(URL) {
			return mraid_bridge.openRichMediaAdOverlay(URL);
		},

		setModalVCProperties : function(properties) {
				
			mraid_bridge.setMraidViewProperties(properties.backgroundColor, properties.alpha, properties.isMraid, properties.transitionStyle, properties.closeButtonPosition);
		},

		playVideo : function(URI) {
			return mraid_bridge.playVideo(URI);
		},

		exitApplicationAlert : function(bool, alertData) {
			mraid_bridge.setExitApplicationAlertData(bool, alertData.title, alertData.text, alertData.cancelLabel, alertData.okLabel );
		},

		useCustomClose : function(bool) {
			if(bool === 0) {
				bool = false;
			}else if(bool === 1) {
				bool = true;
			}
			mraid_bridge.useCustomClose(bool);
		},

		setCloseButtonPosition : function(str) {
			mraid_bridge.setCloseButtonPosition(str);
		},
		
		getAbsolutScreenSize : function() {			

			return absSize;
		},

		getMaxSize : function() {

			/*
			 * For testing. This need to be set from Java
			 */
			var maxSize = {
				x : 0,
				y : 0,
				width : 320,
				height : 480
			};

			return maxSize;
		},

		validate : function(obj, validators, action, merge) {
			if (!merge) {
				// Check to see if any required properties are missing.
				if (obj === null) {
					return false;
				} else {
					for ( var i in validators) {
						if (validators.hasOwnProperty(i)
								&& obj[i] === undefined) {
							return false;
						}
					}
				}
			}

			for ( var prop in obj) {
				var validator = validators[prop];
				var value = obj[prop];
				if (validator && !validator(value)) {
					// Failed validation.
					return false;
				}
			}

			return true;

		},

		setResizeProperties : function(properties) {
			if (mraid.validate(properties, resizePropertyValidators,
					'setResizeProperties', true)) {
				var desiredProperties = [ 'width', 'height', 'offsetX',
						'offsetY', 'customClosePosition', 'allowOffsceen' ];
				var length = desiredProperties.length;
				for ( var i = 0; i < length; i++) {
					var propname = desiredProperties[i];
					if (properties.hasOwnProperty(propname))
						resizeProperties[propname] = properties[propname];
				}
			}
		},

		getResizeProperties : function() {
			var properties = {
				width : resizeProperties.width,
				height : resizeProperties.height,
				offsetX : resizeProperties.offsetX,
				offsetY : resizeProperties.offsetY,
				customClosePosition : resizeProperties.customClosePosition,
				allowOffscreen : resizeProperties.allowOffscreen
			};

			return properties;

		},
		
		resizeOpen : function(anim, position, closePos, offscreen, size) {
			
			return mraid_bridge.resizeOpen(anim, position, closePos, offscreen, size);
		},
		
		resizeClose : function(anim, position, closePos, offscreen, creativeTriggerHeight, hasStandardTrigger) {
			
			return mraid_bridge.resizeClose(anim, position, closePos, offscreen, creativeTriggerHeight, hasStandardTrigger);
		},
		
		setExpandProperties : function(properties) {
			
			var desiredProperties = [ 'width', 'height', 'useCustomClose', 'isModal', 'lockOrientation'];
			
			var length = desiredProperties.length;
			for ( var i = 0; i < length; i++) {
				var propname = desiredProperties[i];
				if (properties.hasOwnProperty(propname))
					expandProperties[propname] = properties[propname];
			}
			
			return mraid_bridge.setExpandProperties(expandProperties['width'], expandProperties['height'], expandProperties['useCustomClose'], 
					expandProperties['isModal'], expandProperties['lockOrientation']);
			
		},
		
		getExpandProperties : function() {
			
			return expandProperties;
		},
		
		expand : function() {
			
			return mraid_bridge.expand();
		},
		
		setDimmingViewProperties : function(color, opacity) {
			
			
		},
		resize : function(animated) {
						
			return mraid_bridge.resize(resizeProperties.width,
					resizeProperties.height, 
					resizeProperties.offsetX,
					resizeProperties.offsetY,
					resizeProperties.customClosePosition,
					resizeProperties.allowOffscreen, 
					animated);
		},
		
		hideCustomControls: function () {
			var mute = document.getElementById("__mute__");
			mute.style.display = "none";
			var controls = document.getElementById("__controls__");
			controls.style.display = "none";
		}

	};

	// ----------------------- Members & Fields/Arrays
	// ------------------------//

	var CLOSEBTUTTONPOS = mraid.CLOSEBTUTTONPOS = {

		TL : 'top-left',
		TR : 'top-right',
		BL : 'bottom-left',
		BR : 'bottom-right'

	};

	// Properties which define the behavior of a resizeable ad.
	var resizeProperties = {
		width : -1,
		height : -1,
		customClosePosition : CLOSEBTUTTONPOS.TR,
		offsetX : 0,
		offsetY : 0,
		allowOffscreen : false
	};

	var resizePropertyValidators = {
		width : function(v) {
			return !isNaN(v) && v >= 0;
		},
		height : function(v) {
			return !isNaN(v) && v >= 0;
		},
		offsetX : function(v) {
			return !isNaN(v);
		},
		offsetY : function(v) {
			return !isNaN(v);
		},
		customClosePosition : function(v) {
			return (v == CLOSEBTUTTONPOS.BL || v == CLOSEBTUTTONPOS.BR
					|| v == CLOSEBTUTTONPOS.TL || v == CLOSEBTUTTONPOS.TR);
		},
		allowOffscreen : function(v) {
			return (typeof v === 'boolean');
		}
	};

}).call(this);
